<?php

class GetWebObject
{
  var $host     = "";
  var $port     = "";
  var $path     = "";
  var $header   = array();
  var $content  = "";
  
  var $C_SUCCESSFUL         = 0;
  var $C_CONNECTION_FAILED  = 1;
  var $C_OBJECT_NOT_AVAIL   = 2;
  
  function GetWebObject($host, $port, $path)
  {
    $this->host = $host;
    $this->port = $port;
    $this->path = $path;
  }
  
  function fetch()
  {
    $fp = fsockopen ($this->host, $this->port, $errno, $errstr, 5);
    
    if(!$fp)
    { 
      // $errstr, $errno contain the real err msg
      return($this->C_CONNECTION_FAILED);
    }
    
    $header_done=false;
    
    $request  = "GET ".$this->path." HTTP/1.0\r\n";
    $request .= "User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n";
    $request .= "Host: ".$this->host."\r\n";
    $request .= "Connection: Close\r\n\r\n";
    $return = '';

    fputs ($fp, $request);
    
    $line = fgets ($fp, 512);
    $this->header["status"] = $line;
    
    while (!feof($fp))
    {
      if($header_done)
      { 
        $line = fread ( $fp, 1024 );
        $this->content .= $line;
      }
      else
      {
        $line = fgets ($fp, 1024);
        if($line == "\r\n")
        { $header_done=true;}
        else
        {
          $data = explode(":",$line);
          $this->header[trim($data[0])] = trim($data[1]);
        }
      }
    }
    fclose ($fp);
    
    if(preg_match("/200 OK/i", $this->header['status']))
    { return($this->C_SUCCESSFUL);}
    return($this->C_OBJECT_NOT_AVAIL);
  }
  
  function getHeader()
  { return($this->header);}
  
  function getContent()
  { return($this->content);}
  
  function setPath($path)
  { 
    $this->content = null;
    $this->path = $path;
  }
  
  function getShortErrDesc($no)
  {
    switch($no)
    {
      case $this->C_SUCCESSFUL:
        return("successful");
      case $this->C_CONNECTION_FAILED:
        return("no connection");
      case $this->C_OBJECT_NOT_AVAIL:
        return("not available (404)");
      default:
        return("unknown error");
    }
  }

  function getLongErrDesc($no)
  {
    switch($no)
    {
      case $this->C_SUCCESSFUL:
        return("Object successfuly fetched");
      case $this->C_CONNECTION_FAILED:
        return("Could not connect to host");
      case $this->C_OBJECT_NOT_AVAIL:
        return("Object not available on host");
      default:
        return("Unknown error code ($no)");
    }
  }
}
?>